<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Call Instructions</TITLE>
<link href="suif1_36.html" rel=Next>
<link href="suif1_34.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_34.html">previous</A>, <A HREF="suif1_36.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC35" HREF="suif1_toc.html#TOC35">Call Instructions</A></H2>
<P>
<A NAME="IDX209"></A>
<A NAME="IDX210"></A>

</P>
<P>
<A NAME="IDX211"></A>
<A NAME="IDX212"></A>
<A NAME="IDX213"></A>
SUIF uses a special <CODE>cal</CODE> instruction to represent procedure calls.
This high-level representation hides the details of various linkage
conventions.  The <CODE>in_cal</CODE> class is used to represent these call
instructions.  A call instruction contains a source operand to hold a
pointer to the procedure to be called.  The <CODE>addr_op</CODE> and
<CODE>set_addr_op</CODE> methods access this operand field.

</P>
<P>
<A NAME="IDX214"></A>
<A NAME="IDX215"></A>
<A NAME="IDX216"></A>
<A NAME="IDX217"></A>
The actual parameters for the procedure are stored in an array of
operands.  The <CODE>num_args</CODE> method returns the number of elements in
this array.  The size of the array can be changed at any time using the
<CODE>set_num_args</CODE> method.  If necessary, the array will be
reallocated.  Elements of the argument array may be accessed using the
<CODE>argument</CODE> and <CODE>set_argument</CODE> methods.  You must specify the
array index.  The first argument is at index zero.

</P>
<P>
Call instructions must obey some conventions on the types of the
operands.  The <CODE>addr</CODE> operand must hold a pointer to a function
type which is compatible with the type of the procedure being called.
The result type of the call instruction must match the return type of
the procedure.  The restrictions on instruction result types
(see section <A HREF="suif1_26.html#SEC26">Result Types</A>) guarantee that the return type will either be
void or have known, non-zero size.  If the function type specifies the
number of arguments, it must match the number of actual parameters
(unless the function takes a variable number of arguments).  Moreover,
each operand in the argument array must be compatible with the type of
the corresponding formal parameter.  Whether or not the function type
specifies the argument types, the restrictions on instruction result
types (see section <A HREF="suif1_26.html#SEC26">Result Types</A>) and variables (see section <A HREF="suif1_55.html#SEC55">Variable Symbols</A>)
guarantee that all arguments will have known, non-zero size.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_34.html">previous</A>, <A HREF="suif1_36.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
